/* Implementation av lnkad hashtabell -- linkhash.c */

#include "linkhash.h"
#include <stdlib.h>

void initlinkhash(linktyp *htab[])
{
   int i;

   for ( i = 0; i < HASHTABSIZE; i++)
      htab[i] = NULL;
}


void intolinkhash(linktyp *htab[], datatyp d,
		  int (*hashfunk)(datatyp))
{
   int index;
   linktyp *lp;

   index = hashfunk(d) % HASHTABSIZE;
   lp = malloc(sizeof(linktyp));
   lp->data = d;
   lp->next = htab[index];
   htab[index] = lp;
}

linktyp *searchlinkhash(linktyp *htab[], datatyp nyckel,
			int (*hashfunk)(datatyp),
			int (*is_equal)(datatyp, datatyp))
{
   int index;
   linktyp *lp;

   index = hashfunk(nyckel) % HASHTABSIZE;
   lp = htab[index];
   while (lp != NULL && !is_equal(nyckel, lp->data))
      lp = lp->next;
   return lp;
}
