/* Implementation av binra trdet -- tree.c */

#include "tree.h"
#include <stdlib.h>

void intotree(nodtyp **rpp, datatyp d, int (*is_less)(datatyp, datatyp))
{
   if ( *rpp == NULL )
   {
      *rpp = malloc(sizeof(nodtyp));
      (*rpp)->data = d;
      (*rpp)->left = NULL;
      (*rpp)->right = NULL;
   }
   else if ( is_less(d, (*rpp)->data) )
      intotree(&(*rpp)->left, d, is_less);
   else
      intotree(&(*rpp)->right, d, is_less);
}


void showtree(nodtyp *rp, void (*write_data)(datatyp))
{
   if ( rp != NULL )
   {
      showtree(rp->left, write_data);
      write_data(rp->data);
      showtree(rp->right, write_data);
   }
}


nodtyp *searchtree(nodtyp *rp, datatyp key,
		   int (*is_equal)(datatyp, datatyp),
		   int (*is_less)(datatyp, datatyp))
{
   if (rp == NULL)
      return NULL;
   else if ( is_equal(key, rp->data) )
      return rp;
   else if (is_less(key, rp->data))
      return searchtree(rp->left, key, is_equal, is_less);
   else
      return searchtree(rp->right, key, is_equal, is_less);
}